

AGlShaderText peak_text = {" \
void main() \
{ \
   gl_TexCoord[0] = gl_MultiTexCoord1; \
   gl_TexCoord[1] = gl_MultiTexCoord2; \
   gl_TexCoord[2] = gl_MultiTexCoord3; \
   gl_TexCoord[3] = gl_MultiTexCoord4; \
   gl_Position = ftransform(); \
} \
",
" \
uniform sampler1D tex1d; \
uniform sampler1D tex1d_neg; \
uniform sampler1D tex1d_3; \
uniform sampler1D tex1d_4; \
uniform float peaks_per_pixel; \
uniform float top; \
uniform float bottom; \
uniform vec4 fg_colour; \
uniform int n_channels; \
void main(void) \
{ \
 float object_height = (bottom - top) / 256.0; \
 float d = 1.0 / 256.0; \
 float y = gl_TexCoord[0].t; \
 float mid = 0.5; \
 float mid_rhs = 0.75; \
 float h = 1.0; \
 if(n_channels == 2){ \
  mid = 0.25; \
  h = 0.5; \
 } \
 float over_sample = (peaks_per_pixel == 1.0) ? 1.0 : 2.0; \
 d = d / over_sample; \
 float alpha_range = 0.5; \
 float val = 0.0; \
 float peak_pstv; \
 float peak_negv; \
 int i; \
 float aa = alpha_range / (peaks_per_pixel * over_sample); \
 int n = int(max(1, peaks_per_pixel * over_sample)) + 2; \
 const int N_WIN = 16; \
 n = int(min(n, N_WIN)); \
 float window[N_WIN]; \
  window[ 2] = 1.0; \
  window[ 3] = 1.0; \
  window[ 4] = 1.0; \
  window[ 5] = 1.0; \
  window[ 6] = 1.0; \
  window[ 7] = 1.0; \
  window[ 8] = 1.0; \
  window[ 9] = 1.0; \
  window[10] = 1.0; \
  window[11] = 1.0; \
  window[12] = 1.0; \
  window[13] = 1.0; \
 if(n > 3){ \
 window[ 0] = 0.25; \
 window[ 1] = 0.75; \
 window[n-2] = 0.75; \
 window[n-1] = 0.25; \
 }else{ \
  window[ 0] = 1.00; \
  window[ 1] = 1.00; \
  window[ 2] = 0.00; \
 } \
 int c_max = int(min(n_channels, 2)); \
 int c;for(c=0;c<c_max;c++){ \
  float mid_ = (c == 0) ? mid : mid_rhs; \
  if((c == 0 && y < h) || (c == 1 && y > h)){ \
   for(i=0;i<n;i++){ \
    float tx = min(0.9999, gl_TexCoord[0].x + max(0.0, float(i - n/2)) * d); \
    float bb = aa * window[i]; \
    if (y > mid_) { \
     peak_pstv = (c == 0) ? texture1D(tex1d, tx).a : texture1D(tex1d_3, tx).a; \
     if(y - mid_ < peak_pstv * h) val += bb; \
    } else { \
     peak_negv = (c == 0) ? texture1D(tex1d_neg, tx).a : texture1D(tex1d_4, tx).a; \
     if(-y + mid_ < peak_negv * h) val += bb; \
    } \
   } \
  } \
 } \
 if(val > 0.0) val += (1.0 - alpha_range); \
 gl_FragColor = vec4(min(1.0, val)) * fg_colour; \
} \
"
};

AGlShaderText peak_nonscaling_text = {" \
void main() \
{ \
   gl_TexCoord[0] = gl_MultiTexCoord1; \
   gl_TexCoord[1] = gl_MultiTexCoord2; \
   gl_TexCoord[2] = gl_MultiTexCoord3; \
   gl_TexCoord[3] = gl_MultiTexCoord4; \
   gl_Position = ftransform(); \
} \
",
" \
uniform sampler1D tex1d; \
uniform sampler1D tex1d_0neg; \
uniform sampler1D tex1d_3; \
uniform sampler1D tex1d_4; \
uniform int n_channels; \
void main(void) \
{ \
 float top = 0.0; \
 float bottom = 256.0; \
 float peaks_per_pixel = 1.0; \
 float object_height = (bottom - top) / 256.0; \
 float d = 1.0 / 256.0; \
 float y = gl_TexCoord[0].t; \
 float mid = 0.5; \
 float mid_rhs = 0.75; \
 float h = 1.0; \
 if(n_channels == 2){ \
  mid = 0.25; \
  h = 0.5; \
 } \
 float alpha_range = 0.5; \
 float val = 0.0; \
 float peak_pstv; \
 float peak_negv; \
 int n = 1; \
 int c_max = int(min(n_channels, 2)); \
 int c;for(c=0;c<c_max;c++){ \
  float mid_ = (c == 0) ? mid : mid_rhs; \
  if((c == 0 && y < h) || (c == 1 && y > h)){ \
   float tx = gl_TexCoord[0].x + max(0.0, float(-n/2)) * d; \
   float bb = alpha_range; \
   if (y > mid_) { \
    peak_pstv = (c == 0) ? texture1D(tex1d, tx).a : texture1D(tex1d_3, tx).a; \
    if(y - mid_ < peak_pstv * h) val += bb; \
   } else { \
    peak_negv = (c == 0) ? texture1D(tex1d_0neg, tx).a : texture1D(tex1d_4, tx).a; \
    if(-y + mid_ < peak_negv * h) val += bb; \
   } \
  } \
 } \
 if(val > 0.0) val += (1.0 - alpha_range); \
 gl_FragColor = vec4(min(1.0, val)); \
} \
"
};

AGlShaderText horizontal_text = {" \
varying vec2 MCposition; \
void main() \
{ \
   gl_TexCoord[0] = gl_MultiTexCoord0; \
   gl_Position = ftransform(); \
} \
",
" \
uniform sampler2D tex2d; \
uniform vec4 fg_colour; \
uniform float peaks_per_pixel; \
const float blurSize = 1.0/256.0; \
void main(void) \
{ \
 float w1 = 0.75; \
 float w2 = 0.25; \
 float l[11]; \
 for(int i=0;i<11;i++) l[i] = 0.0; \
 float blur_size = blurSize * peaks_per_pixel; \
 vec4 sum = vec4(0.0); \
 vec4 bloom = vec4(0.0); \
 sum += texture2D(tex2d, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y)) * w1; \
 float m[4]; \
 m[0] = 1.00; \
 m[1] = 2.00; \
 m[2] = 4.00; \
 m[3] = 8.00; \
 float mm = 1.0; \
 if(true || sum.r < 1.0 || (sum.a < 1.0)){ \
  if(peaks_per_pixel > m[0]){ \
   mm = 2.0; \
   if(peaks_per_pixel > m[1]){ \
    mm = 3.0; \
    if(peaks_per_pixel > m[2]){ \
     mm = 4.0; \
     if(peaks_per_pixel > m[3]){ \
      l[-4 + 5] += (peaks_per_pixel - m[3]) * w1; \
      l[ 4 + 5] += (peaks_per_pixel - m[3]) * w1; \
     } \
     l[-3 + 5] += (peaks_per_pixel - m[2]) * w1; \
     l[ 3 + 5] += (peaks_per_pixel - m[2]) * w1; \
    } \
    l[-2 + 5] += (peaks_per_pixel - m[1]) * w1; \
    l[ 2 + 5] += (peaks_per_pixel - m[1]) * w1; \
   } \
   l[-1 + 5] += (peaks_per_pixel - m[0]) * w1; \
   l[ 1 + 5] += (peaks_per_pixel - m[0]) * w1; \
  } \
  float minv = 0.3; \
  for(int i=0;i<11;i++) if(l[i] > 0.0) l[i] = min(minv + l[i] * (1.0 - minv), 1.0) / mm; \
  if(peaks_per_pixel < 2.0){ \
   l[1] += 0.05 * w2; \
   l[2] += 0.09 * w2; \
   l[3] += 0.12 * w2; \
   l[4] += 0.15 * w2; \
   l[6] += 0.15 * w2; \
   l[7] += 0.12 * w2; \
   l[8] += 0.09 * w2; \
   l[9] += 0.05 * w2; \
  }else{ \
   l[1] += 0.12 * w2; \
   l[3] += 0.15 * w2; \
   l[7] += 0.15 * w2; \
   l[9] += 0.12 * w2; \
  } \
  for(int i=0;i<11;i++) if(l[i] > 0.0) sum += texture2D(tex2d, vec2(gl_TexCoord[0].x + float(i - 5) * blurSize, gl_TexCoord[0].y)) * l[i]; \
 } \
 sum = min(sum, 1.0); \
 gl_FragColor = vec4(sum.r, sum.r, sum.r, sum.a) * fg_colour; \
} \
"
};

AGlShaderText vertical_text = {" \
varying vec2 MCposition; \
void main() \
{ \
   gl_TexCoord[0] = gl_MultiTexCoord0; \
   gl_Position = ftransform(); \
} \
",
" \
uniform sampler2D tex2d; \
uniform vec4 fg_colour; \
const float blurSize = 1.0/256.0; \
void main(void) \
{ \
 vec4 sum = vec4(0.0); \
 sum += texture2D(tex2d, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y - 4.0*blurSize)) * 0.05; \
 sum += texture2D(tex2d, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y - 3.0*blurSize)) * 0.09; \
 sum += texture2D(tex2d, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y - 2.0*blurSize)) * 0.12; \
 sum += texture2D(tex2d, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y - 1.0*blurSize)) * 0.15; \
 sum += texture2D(tex2d, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y )) * 0.16; \
 sum += texture2D(tex2d, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y + 1.0*blurSize)) * 0.15; \
 sum += texture2D(tex2d, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y + 2.0*blurSize)) * 0.12; \
 sum += texture2D(tex2d, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y + 3.0*blurSize)) * 0.09; \
 sum += texture2D(tex2d, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y + 4.0*blurSize)) * 0.05; \
 gl_FragColor = sum * fg_colour; \
} \
"
};

AGlShaderText hires_text = {" \
void main() \
{ \
   gl_TexCoord[0] = gl_MultiTexCoord1; \
   gl_TexCoord[1] = gl_MultiTexCoord2; \
   gl_TexCoord[2] = gl_MultiTexCoord3; \
   gl_TexCoord[3] = gl_MultiTexCoord4; \
   gl_Position = ftransform(); \
} \
",
" \
uniform sampler1D tex1d; \
uniform sampler1D tex1d_neg; \
uniform sampler1D tex1d_3; \
uniform sampler1D tex1d_4; \
uniform float peaks_per_pixel; \
uniform float top; \
uniform float bottom; \
uniform vec4 fg_colour; \
uniform int n_channels; \
void main(void) \
{ \
 float object_height = (bottom - top) / 256.0; \
 float d = 1.0 / 4096.0; \
 float y = gl_TexCoord[0].t; \
 float mid = 0.5; \
 float mid_rhs = 0.75; \
 float h = 1.0; \
 if(n_channels == 2){ \
  mid = 0.25; \
  h = 0.5; \
 } \
 float over_sample = 2.0; \
 d = d / over_sample; \
 float alpha_range = 0.05; \
 if(peaks_per_pixel < 6.0) alpha_range = 0.75; \
 if(peaks_per_pixel < 3.0) alpha_range = 0.5; \
 float val = 0.0; \
 float peak_pstv; \
 float peak_negv; \
 int i; \
 float aa = alpha_range / (peaks_per_pixel * over_sample); \
 int n = int(max(1, peaks_per_pixel * over_sample)) + 2; \
 for(i=-n/2;i<n/2;i++){ \
  float tx = min(0.99999, gl_TexCoord[0].x + float(i) * d); \
  if (y > mid) { \
   peak_pstv = texture1D(tex1d, tx).a; \
   if(y - mid < peak_pstv * h) val += aa; \
  } else { \
   peak_negv = texture1D(tex1d_neg, tx).a; \
   if(-y + mid < peak_negv * h) val += aa; \
  } \
  if(n_channels == 2){ \
   if (y > mid_rhs) { \
    peak_pstv = texture1D(tex1d_3, tx).a; \
    if(y - mid_rhs < peak_pstv * h) val += aa; \
   } else if (y > 0.5) { \
    peak_negv = texture1D(tex1d_4, tx).a; \
    if(-y + mid_rhs < peak_negv * h) val += aa; \
   } \
  } \
 } \
 if(val > 0.0) val += (1.0 - alpha_range); \
 gl_FragColor = vec4(min(1.0, val)) * fg_colour; \
} \
"
};

AGlShaderText hires_ng_text = {" \
attribute vec4 vertex; \
uniform vec2 modelview; \
uniform vec2 translate; \
varying vec2 tex_coords; \
varying vec2 position; \
void main () \
{ \
 tex_coords = vertex.zw; \
 position = vertex.xy; \
 gl_Position = vec4(vec2(1., -1.) * (vertex.xy + translate) / modelview - vec2(1.0, -1.0), 1.0, 1.0); \
} \
",
" \
uniform sampler2D tex2d; \
uniform float top; \
uniform float bottom; \
uniform vec4 fg_colour; \
uniform int n_channels; \
uniform float v_gain; \
uniform float tex_height; \
uniform float tex_width; \
uniform int mm_level; \
varying vec2 position; \
varying vec2 tex_coords; \
const vec4 x_gain = vec4(1.0, 2.0, 4.0, 8.0); \
const vec4 mm2tx = vec4(0.00, 0.00, 0.50, 0.75); \
const vec4 mm2ty = vec4(0.0, 1.0, 1.0, 1.0); \
const vec4 tx_min = vec4(0.0, 0.0, 0.5, 0.75); \
void main (void) \
{ \
 float dx = 1.0 / tex_width; \
 float y = bottom - position.y; \
 float mid = (bottom - top) / 2.0; \
 float mid3 = mid; \
 vec2 t = vec2(mm2tx[mm_level], mm2ty[mm_level]); \
 int c = 0; \
 float yc = y; \
 if(n_channels < 2){ \
  yc = (y - mid) / v_gain + mid; \
 }else{ \
  if(y < mid - 1.0){ \
   mid3 = mid / 2.0; \
   mid -= mid / 2.0; \
   yc = (y - mid3) / v_gain + mid3; \
  }else if(y > mid + 1.0){ \
   c = 1; \
   mid3 = mid / 2.0; \
   yc = (y - mid - mid3) / v_gain + mid3; \
   mid += mid / 2.0; \
   t.y += 4.0; \
  }else{ \
   discard; \
  } \
 } \
 float smooth = (abs(y - mid) > 2.0) ? 2.0 : 1.0; \
 float y1, y2; \
 if(y < mid){ \
  t.y = t.y / tex_height + tex_coords.y; \
  y1 = (mid3 - (yc + smooth)) / mid3; \
  y2 = (mid3 - (yc - smooth)) / mid3; \
 }else{ \
  t.y = (t.y + 2.0) / tex_height + tex_coords.y; \
  y1 = ((yc - smooth) - mid3) / mid3; \
  y2 = ((yc + smooth) - mid3) / mid3; \
 } \
 t.x += tex_coords.x / x_gain[mm_level]; \
 vec4 colour = fg_colour; \
 colour.a *= min(1.0, \
   smoothstep(y1, y2, texture2D(tex2d, vec2(t.x, t.y)).a) * 0.70 + \
   smoothstep(y1, y2, texture2D(tex2d, vec2(max(mm2tx[mm_level], t.x - dx), t.y)).a) * 0.40 + \
   smoothstep(y1, y2, texture2D(tex2d, vec2(t.x + dx, t.y)).a) * 0.40 \
 ); \
 gl_FragColor = colour; \
} \
"
};

AGlShaderText ruler_text = {" \
attribute vec4 vertex; \
uniform vec2 modelview; \
uniform vec2 translate; \
varying vec2 MCposition; \
varying vec2 ecPosition; \
void main() \
{ \
   MCposition = gl_Vertex.xy; \
   ecPosition = (gl_ModelViewMatrix * gl_Vertex).xy; \
   gl_Position = vec4(vec2(1., -1.) * (gl_Vertex.xy + translate) / modelview - vec2(1.0, -1.0), 1.0, 1.0); \
} \
",
" \
uniform float samples_per_pixel; \
uniform float beats_per_pixel; \
uniform float viewport_left; \
uniform vec4 fg_colour; \
uniform int markers[10]; \
varying vec2 MCposition; \
varying vec2 ecPosition; \
void main(void) \
{ \
 vec4 marker_colours[10]; \
 marker_colours[0] = vec4(0.5, 0.8, 0.5, 1.0); \
 marker_colours[1] = vec4(0.5, 0.6, 0.8, 1.0); \
 marker_colours[2] = vec4(0.5, 0.6, 0.8, 1.0); \
 marker_colours[3] = vec4(0.5, 0.6, 0.8, 1.0); \
 marker_colours[4] = vec4(0.5, 0.6, 0.8, 1.0); \
 marker_colours[5] = vec4(0.5, 0.6, 0.8, 1.0); \
 marker_colours[6] = vec4(0.5, 0.6, 0.8, 1.0); \
 marker_colours[7] = vec4(0.5, 0.6, 0.8, 1.0); \
 marker_colours[8] = vec4(0.5, 0.6, 0.8, 1.0); \
 marker_colours[9] = vec4(0.8, 0.6, 0.5, 1.0); \
 vec4 c = vec4(1.0) * fg_colour; \
 float alpha = c[3]; \
 c[3] = 0.0; \
 float pixels_per_beat = 1.0 / beats_per_pixel; \
 float pixels_per_bar = pixels_per_beat * 4.0; \
 if(MCposition.y > 20.0){ \
  int i; for(i=0;i<10;i++){ \
   float locator_x = float(markers[i]) / samples_per_pixel - viewport_left; \
   if(MCposition.x > locator_x - 0.05 && MCposition.x < locator_x + 8.0){ \
    gl_FragColor = marker_colours[i]; \
    return; \
   } \
  } \
 } \
 float interval = 0.0; \
 if(MCposition.y < 3.0){ \
  interval = (pixels_per_beat < 1.5) \
   ? pixels_per_beat * 4.0 \
   : (pixels_per_beat < 6.0) \
    ? pixels_per_beat \
    : (pixels_per_beat < 24.0) \
     ? pixels_per_beat / 4.0 \
     : pixels_per_beat / 16.0; \
 }else if(MCposition.y < 8.0){ \
  interval = (pixels_per_beat < 1.5) \
   ? pixels_per_beat * 16.0 \
   : (pixels_per_beat < 6.0) \
    ? pixels_per_beat * 4.0 \
    : (pixels_per_beat < 24.0) \
     ? pixels_per_beat \
     : pixels_per_beat / 4.0; \
 }else if(MCposition.y < 50.0){ \
  interval = (pixels_per_beat < 1.5) \
   ? pixels_per_bar * 16.0 \
   : (pixels_per_beat < 6.0) \
    ? pixels_per_bar * 4.0 \
    : pixels_per_bar; \
 } \
 float m = floor(mod((MCposition.x - 0.0 + viewport_left), interval)); \
 float val = m < 1.0 ? 1.0 : 0.0; \
 c[3] = alpha * val; \
 gl_FragColor = c; \
} \
"
};

AGlShaderText ruler_bottom_text = {" \
attribute vec4 vertex; \
uniform vec2 modelview; \
uniform vec2 translate; \
varying vec2 MCposition; \
varying vec2 ecPosition; \
void main () \
{ \
   MCposition = gl_Vertex.xy; \
   ecPosition = (gl_ModelViewMatrix * gl_Vertex).xy; \
   gl_Position = vec4(vec2(1., -1.) * (gl_Vertex.xy + translate) / modelview - vec2(1.0, -1.0), 1.0, 1.0); \
} \
",
" \
uniform float samples_per_pixel; \
uniform float beats_per_pixel; \
uniform float viewport_left; \
uniform vec4 fg_colour; \
uniform int markers[10]; \
varying vec2 MCposition; \
varying vec2 ecPosition; \
void main(void) \
{ \
 vec4 marker_colours[10]; \
 marker_colours[0] = vec4(0.5, 0.8, 0.5, 1.0); \
 marker_colours[1] = vec4(0.5, 0.6, 0.8, 1.0); \
 marker_colours[2] = vec4(0.5, 0.6, 0.8, 1.0); \
 marker_colours[3] = vec4(0.5, 0.6, 0.8, 1.0); \
 marker_colours[4] = vec4(0.5, 0.6, 0.8, 1.0); \
 marker_colours[5] = vec4(0.5, 0.6, 0.8, 1.0); \
 marker_colours[6] = vec4(0.5, 0.6, 0.8, 1.0); \
 marker_colours[7] = vec4(0.5, 0.6, 0.8, 1.0); \
 marker_colours[8] = vec4(0.5, 0.6, 0.8, 1.0); \
 marker_colours[9] = vec4(0.8, 0.6, 0.5, 1.0); \
 vec4 c = vec4(1.0) * fg_colour; \
 float alpha = c[3]; \
 c[3] = 0.0; \
 float pixels_per_beat = 1.0 / beats_per_pixel; \
 float pixels_per_sec = 2.0 / beats_per_pixel; \
 float pixels_per_bar = pixels_per_beat * 4.0; \
 if (MCposition.y > 20.0) { \
  for (int i=0;i<10;i++) { \
   float locator_x = float(markers[i]) / samples_per_pixel - viewport_left; \
   if(MCposition.x > locator_x - 0.05 && MCposition.x < locator_x + 8.0){ \
    gl_FragColor = marker_colours[i]; \
    return; \
   } \
  } \
 } \
 float interval = 0.0; \
 if (MCposition.y > 17.0) { \
  interval = pixels_per_sec * 9.6 / float(int(1.9 * pixels_per_beat) + 1); \
 } else if (MCposition.y > 14.0) { \
  interval = pixels_per_sec * 48.0 / float(int(1.9 * pixels_per_beat) + 1); \
 } else if (MCposition.y > 10.0) { \
  interval = pixels_per_sec * 240.0 / float(int(1.9 * pixels_per_beat) + 1); \
 } else { \
  interval = pixels_per_sec * 480.0 / float(int(1.9 * pixels_per_beat) + 1); \
 } \
 float m = floor(mod((MCposition.x + viewport_left), interval)); \
 float val = m < 1.0 ? 1.0 : 0.0; \
 c[3] = alpha * val; \
 gl_FragColor = c; \
} \
"
};

AGlShaderText ass_text = {" \
attribute vec4 vertex; \
uniform vec2 modelview; \
uniform vec2 translate; \
varying vec2 tex_coords; \
void main () \
{ \
 tex_coords = vertex.zw; \
 gl_Position = vec4(vec2(1., -1.) * (vertex.xy + translate) / modelview - vec2(1.0, -1.0), 1.0, 1.0); \
} \
",
" \
uniform sampler2D tex2d; \
uniform vec4 colour1; \
uniform vec4 colour2; \
varying vec2 tex_coords; \
void main () \
{ \
 float rr = texture2D(tex2d, tex_coords.xy).r; \
 float l0 = colour1[0] * rr + colour2[0] * (1.0 - rr); \
 float l1 = colour1[1] * rr + colour2[1] * (1.0 - rr); \
 float l2 = colour1[2] * rr + colour2[2] * (1.0 - rr); \
 gl_FragColor = vec4(l0, l1, l2, colour1[3] * texture2D(tex2d, tex_coords.xy).a); \
} \
"
};

AGlShaderText lines_text = {" \
attribute vec4 vertex; \
uniform vec2 modelview; \
uniform vec2 translate; \
varying vec2 tex_coords; \
varying vec2 position; \
void main () \
{ \
 position = vertex.xy; \
 tex_coords = vertex.zw; \
 gl_Position = vec4((vertex.xy + translate) / modelview - vec2(1.0, -1.0), 1.0, 1.0); \
} \
",
" \
uniform vec4 colour; \
uniform int n_channels; \
uniform float texture_width; \
uniform sampler2D tex; \
varying vec2 position; \
varying vec2 tex_coords; \
float dist_to_line (vec2 pt1, vec2 pt2, vec2 testPt) \
{ \
    if(testPt.y > max(pt1.y, pt2.y)) return 4.0 * abs(testPt.y - max(pt1.y, pt2.y)); \
    if(testPt.y < min(pt1.y, pt2.y)) return 4.0 * abs(testPt.y - min(pt1.y, pt2.y)); \
 vec2 lineDir = pt2 - pt1; \
 vec2 perpDir = vec2(lineDir.y, -lineDir.x); \
 vec2 dirToPt1 = pt1 - testPt; \
 return abs(dot(normalize(perpDir), dirToPt1)); \
} \
float dist_to_line1 (vec2 pt1, vec2 pt2, vec2 testPt) \
{ \
 if(testPt.y > max(pt1.y, pt2.y) + 0.5) return 1000.0; \
 if(testPt.y < min(pt1.y, pt2.y) - 0.5) return 1000.0; \
 if(pt2.y > pt1.y){ \
  return (pt2.y - testPt.y) / (pt2.y - pt1.y); \
 }else{ \
  return (testPt.y - pt2.y) / (pt1.y - pt2.y); \
 } \
 return 1000.0; \
} \
float dist_to_line2 (vec2 pt1, vec2 pt2, vec2 testPt) \
{ \
 if(testPt.y > max(pt1.y, pt2.y) + 0.5) return 1000.0; \
 if(testPt.y < min(pt1.y, pt2.y) - 0.5) return 1000.0; \
 if(abs(pt2.y - pt1.y) < 1.0){ \
 } \
 if(pt2.y > pt1.y){ \
  return (testPt.y - pt1.y) / (pt2.y - pt1.y); \
 }else{ \
  return (pt1.y - testPt.y) / (pt1.y - pt2.y); \
 } \
 return 1000.0; \
} \
void main (void) \
{ \
 float y = 256.0 - position.y; \
 int c = (n_channels > 1 && y > 128.0) ? 1 : 0; \
 float ct = float(c) / float(n_channels); \
 if(position.x < 2.0){ \
  gl_FragColor = vec4(1.0, 0.2, 0.1, 0.5); \
  return; \
 } \
 if(y < 4.0){ \
  gl_FragColor = vec4(1.0, 0.8, 0.1, 0.5); \
  return; \
 } \
 if(position.x > 0.1){ \
  float y0 = texture2D(tex, vec2(tex_coords.x - 2.0/texture_width, ct)).a * 256.0; \
  float y1 = texture2D(tex, vec2(tex_coords.x - 1.0/texture_width, ct)).a * 256.0; \
  float y2 = texture2D(tex, vec2(tex_coords.x, ct)).a * 256.0; \
  if(true){ \
   vec2 pt0 = vec2(position.x - 2.0, y0); \
   vec2 pt1 = vec2(position.x - 1.0, y1); \
   vec2 pt2 = vec2(position.x, y2); \
   float x_offset = 0.0; \
   float dist0 = 1.0 * dist_to_line1(pt0, pt1, vec2(position.x - x_offset, y)); \
   float dist1 = 1.0 * dist_to_line2(pt1, pt2, vec2(position.x - x_offset, y)); \
   float dist = min(dist0, dist1); \
   if(dist < 1.0){ \
    gl_FragColor = vec4(colour.r, colour.g, colour.b, 1.0 - dist); \
   }else if(tex_coords.x > 0.495 && tex_coords.x < 0.505){ \
    gl_FragColor = vec4(1.0, 1.0, 0.1, 0.5); \
   }else{ \
    discard; \
   } \
  } \
 }else{ \
  discard; \
 } \
} \
"
};

AGlShaderText cursor_text = {" \
attribute vec4 vertex; \
uniform vec2 modelview; \
uniform vec2 translate; \
varying vec2 position; \
void main () \
{ \
 position = vertex.xy; \
 gl_Position = vec4(vec2(1., -1.) * (vertex.xy + translate) / modelview - vec2(1., -1.), 0., 1.); \
} \
",
" \
uniform vec4 colour; \
uniform float width; \
varying vec2 position; \
void main () \
{ \
 float a1 = 0.5 + 0.5 * max(position.x + 0.5 - (width - 1.0), 0.0); \
 gl_FragColor = vec4( \
  vec3(colour), \
  colour.a * a1 * position.x / width \
 ); \
} \
"
};
